.TH genplot 1 "$Date: 2006-08-18 12:16:24 +0200 (pią, 18 sie 2006) $"
." The first line of this file must contain the '"[e][r][t][v] line
." to tell man to run the appropriate filter "t" for table.
."
."  $Id: genplot.man 139 2006-08-18 10:16:24Z jslawins $
."
."######################################################################
."#                                                                    #
."#                       Copyright (C)  2007                          #
."#                            Internet2                               #
."#                       All Rights Reserved                          #
."#                                                                    #
."######################################################################
."
."  File: genplot.1
."
."  Author: Rich Carlson
."          Internet2
."
." Date: Th Jun 7 15:53:25 CEST 2007
."
." Description:
."
.SH NAME
genplot \- Simple snaplog analyzer for the NDT system.
.SH SYNOPSIS
.B genplot
[\fIoptions\fR]
filelist
.SH DESCRIPTION
The \fBNetwork Diagnostic Tester\fR (NDT) tool is a client/server
program that provides network configuration and performance testing
to a users desktop or laptop computers.  The system is composed of
a client program (\fIcommand line\fR or \fIjava applet\fR) and a pair
of server programs (a webserver and a testing/analysis engine).  
.PP
The \fBgenplot\fR program reads the snaplog generated by the
\fBweb100srv\fR application and prints the information about choosen
Web100 variables. Currently, two output formats are supported: the
plain text table and the xpl files.
.SH OPTIONS
.TP
\fB\-b, --both\fR 
Generate plot of both CurCwnd and CurRwinRcvd.
.TP
\fB\-m, --multi\fR \fIvarlist\fR 
A comma separated list of Web100 vars to plot.
.TP
\fB\-t, --text\fR 
Print variable values instead of generating plots.
.TP
\fB\-C, --CurCwnd\fR 
Generate CurCwnd plot.
.TP
\fB\-R, --CurRwinRcvd\fR 
Generate CurRwinRcvd plot.
.TP
\fB\-S, --throughput\fR 
Generate throughput plot.
.TP
\fB\-c, --cwndtime\fR
Generate Cwnd time plot.
.TP
\fB\-h, --help\fR 
Print a simple usage page and exit.
.TP
\fB\-v, --version\fR 
Print version number and exit.
.SH LIMITATIONS
The NDT service is continuing to undergo testing and upgrading. 
Better diagnostic algorithms are being developed to improve the
accuracy and reliability of this service.
.SH EXAMPLES
.LP
\fBgenplot -tb snaplog\fR
.IP
Print the values of the CurCwnd and CurRwinRcvd. The values are taken
from the \fBsnaplog\fR file.
.SH SEE ALSO
The \%http://e2epi.internet2.edu/ndt/ web site, web100srv(8), web100clt(1), and setsockopt(2).
.SH ACKNOWLEDGMENTS
This material is based in part on work supported by the National Science
Foundation (NSF) under Grant No. ANI-0314723. Any opinions, findings and
conclusions or recommendations expressed in this material are those of
the author(s) and do not necessarily reflect the views of the NSF.
